package AlgLin;

/**
 * @author Hamadou BA  
 * Depot GitLab : https://www-apps.univ-lehavre.fr/forge/bh243413/tp2-ps-resolution-de-systemes-lineaires.git
 *  
 * Classe abstraite representant un systeme lineaire sous la forme d'une matrice  
 * et d'un vecteur second membre.  
 */
public abstract class SysLin {

	private int ordre;
	protected Matrice matriceSystem;
	protected Vecteur secondMembre;

	public SysLin(Matrice m, Vecteur v) throws IrregularSysLinException {
		if (m.nbColonne() != m.nbLigne() || m.nbLigne() != v.getTaille()) {
			throw new IrregularSysLinException("Probleme de taille !");
		}
		this.matriceSystem = m;
		this.secondMembre = v;
		this.ordre = m.nbLigne();
	}

	public int getOrdre() {
		return this.ordre;
	}

	public Matrice getMatriceSystem() {
		return this.matriceSystem;
	}

	public Vecteur getSecondMembre() {
		return this.secondMembre;
	}

	public void setSecondMembre(Vecteur v) {
		this.secondMembre = v;
	}

	public abstract Vecteur resolution() throws IrregularSysLinException;

}
