package tp6.ps;

import AlgLin.IrregularSysLinException;
import java.io.IOException;
import java.util.Scanner;

public class MainApplication {
    
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        
        try {
            System.out.print("Entrez le nom du fichier contenant les points de support (dans src/main/resources/) : ");
            String resourceName = scanner.nextLine();
            
            DataLoader.PointsData pointsData;
            try {
                pointsData = DataLoader.loadFromResource(resourceName);
                System.out.println("Données chargées avec succès : " + pointsData.getSize() + " points.");
            } catch (IOException e) {
                System.out.println("Erreur lors du chargement depuis les ressources. Tentative de chargement depuis le chemin absolu...");
                pointsData = DataLoader.loadFromFile(resourceName);
                System.out.println("Données chargées avec succès : " + pointsData.getSize() + " points.");
            }
            
            System.out.print("Entrez le degré du polynôme souhaité : ");
            int degre = scanner.nextInt();
            
            ModPoly modele = new ModPoly(degre);
            modele.identifie(pointsData.getX(), pointsData.getY());
            
            System.out.println("\nCoefficients du polynôme :");
            System.out.println(modele.getCoefficients());
            System.out.println(modele);
            
            System.out.println("\nAffichage du graphique...");
            ChartPlotter.plotPolynomialFit(
                pointsData, 
                modele, 
                "Approximation par moindres carrés - Polynôme de degré " + degre
            );
            
        } catch (IOException e) {
            System.err.println("Erreur lors du chargement des données : " + e.getMessage());
        } catch (IrregularSysLinException e) {
            System.err.println("Erreur lors de la résolution du système linéaire : " + e.getMessage());
        } catch (Exception e) {
            System.err.println("Erreur inattendue : " + e.getMessage());
            e.printStackTrace();
        } finally {
            scanner.close();
        }
    }
}